SLASH_HELMHIDE1 = "/helmhide"
SLASH_HELMHIDE2 = "/hh"

local helmHideHelmButton
local helmHideCloakButton

function SlashCmdList.HELMHIDE(msg, editbox)
	if msg == "on" then
		helmHideHelmEnabled = true
		helmHideCloakEnabled = true
		print("Helm Hide Enabled")
	elseif msg == "helm" then
		helmHideHelmEnabled = true
		helmHideCloakEnabled = false
		print("Helm Hide Helm Only Enabled")
	elseif msg == "cloak" then
		helmHideHelmEnabled = false
		helmHideCloakEnabled = true
		print("Helm Hidee Claok Only Enabled")
	elseif msg == "off" then
		helmHideEnabled = false
		print("Helm Hide Disabled")
	end
end

function helmHideFrameOnEvent(self, event, message)
	if helmHideHelmEnabled then
		if IsResting() then
			ShowHelm(false)
		else
			ShowHelm(true)
		end
	end
	if helmHideCloakEnabled then
		if IsResting() then
			ShowCloak(false)
		else
			ShowCloak(true)
		end
	end
end

function HelmHideHelmToggle()
	ShowHelm(not ShowingHelm())
end

function HelmHideCloakToggle()
	ShowCloak(not ShowingCloak())
end

function HelmHideCreateButton(icon_on, help, toggle, ...)
	local button = CreateFrame("BUTTON", nil, CharacterModelFrame)
	local hilite = button:CreateTexture(nil, "HIGHLIGHT")
	hilite:SetAllPoints()
	hilite:SetTexture("Interface\\Common\\UI-ModelControlPanel")
	hilite:SetTexCoord(0.57812500, 0.82812500, 0.00781250, 0.13281250)
	button:SetWidth(32)
	button:SetHeight(32)
	button:SetPoint(...)
	button:Hide()
	button:SetNormalTexture(icon_on)
	button:RegisterEvent("PLAYER_FLAGS_CHANGED")
	button:RegisterEvent("PLAYER_ENTERING_WORLD")
	button:SetScript("OnEvent", update)
	button:SetScript("OnClick", function()
		toggle()
	end)
	button:SetScript("OnEnter", function()
		button:SetAlpha(1)
		GameTooltip:SetOwner(button, "ANCHOR_TOPRIGHT")
		GameTooltip:SetText(help, nil, nil, nil, nil, 1)
	end)
	button:SetScript("OnLeave", function()
		button:SetAlpha(0.5)
		GameTooltip_Hide()
		helmHideHelmButton:Hide()
		helmHideCloakButton:Hide()
	end)
	button:SetAlpha(0.5)
	CharacterModelFrame:HookScript("OnEnter", function()
		button:Show()
	end)
	CharacterModelFrame:HookScript("OnLeave", function(self)
		if not self:IsMouseOver() then
			button:Hide()
		end
	end)
	return button
end

local helmHideFrame = CreateFrame("FRAME", nil, UIParent)
helmHideFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
helmHideFrame:RegisterEvent("PLAYER_UPDATE_RESTING");
helmHideFrame:RegisterEvent("ZONE_CHANGED");
helmHideFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
helmHideFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
helmHideFrame:RegisterEvent("PLAYER_LOGIN");
helmHideFrame:SetScript("OnEvent", helmHideFrameOnEvent)

helmHideHelmButton = HelmHideCreateButton("Interface\\AddOns\\HelmHide\\HelmShow", SHOW_HELM, HelmHideHelmToggle, "BOTTOMLEFT", 5, 5)

helmHideCloakButton = HelmHideCreateButton("Interface\\AddOns\\HelmHide\\CloakShow", SHOW_CLOAK, HelmHideCloakToggle, "BOTTOMRIGHT", -5, 5)